package jp.co.intra_mart.journal.sample.endpoint;

import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;

import jp.co.intra_mart.foundation.journal.JournalServiceFactory;
import jp.co.intra_mart.foundation.journal.action.JournalActionRegisterModel;
import jp.co.intra_mart.foundation.journal.action.JournalActionType;
import jp.co.intra_mart.foundation.journal.event.JournalEventGroupKey;
import jp.co.intra_mart.foundation.journal.event.JournalEventRegisterModel;
import jp.co.intra_mart.foundation.journal.event.JournalEventService;
import jp.co.intra_mart.foundation.journal.exception.JournalException;

public class MyService {
    // カスタムイベント情報の設定
    private JournalEventRegisterModel registerJournal() throws JsonProcessingException {

        // 独自のイベントを作成する
        final JournalEventRegisterModel event = new JournalEventRegisterModel();

        // eventGroupKeyを設定する
        final JournalEventGroupKey eventGroupKey = new JournalEventGroupKey();
        eventGroupKey.put("journalSampleId", "1");
        event.setEventGroupKey(eventGroupKey);
        event.setApplication("im-journal-sample");

        // eventTypeId （設定ファイルのevent-type-idに設定した値）
        event.setEventTypeId("im_journal_sample_log");

        // アクションを設定する
        final Set<JournalActionRegisterModel> actions = new HashSet<JournalActionRegisterModel>();
        final JournalActionRegisterModel action = new JournalActionRegisterModel();
        action.setKey("my-action-key");
        action.setType(JournalActionType.REGISTER);

        final Map<String, String> actionData = new HashMap<String, String>();
        final ObjectMapper jsonMapper = new ObjectMapper();
        actionData.put("myData", "123456");

        final String jsonString = jsonMapper.writeValueAsString(actionData);

        action.setData(jsonString);
        actions.add(action);
        event.setActions(actions);

        return event;
    }

    // イベント登録
    public void registerMyEvent() throws JsonProcessingException, JournalException {

        // サービスクラスを呼び出す
        final JournalEventService service = JournalServiceFactory.getJournalEventService();

        // 関数の呼び出し
        final JournalEventRegisterModel event = registerJournal();

        // カスタムイベントを登録する
        service.registerEvent(event);
    }
}
